import { jsx as u, jsxs as d } from "react/jsx-runtime";
import { Children as n, Component as y } from "react";
import { b as v } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-router-dom";
import "react-redux";
import c from "./cssClasses.js";
import I from "./Thumbs.js";
import { slideSwipeAnimationHandler as g, slideStopSwipingHandler as b, fadeAnimationHandler as C, slideAnimationHandler as A } from "./animations.js";
import R from "./utils/domHelper.js";
const w = () => {
}, E = (a, e) => `${a} of ${e}`;
class S extends y {
  constructor(e) {
    super(e), this.setThumbsRef = (t) => {
      this.thumbsRef = t;
    }, this.setCarouselWrapperRef = (t) => {
      this.carouselWrapperRef = t;
    }, this.setListRef = (t) => {
      this.listRef = t;
    }, this.setItemsRef = (t, s) => {
      this.itemsRef || (this.itemsRef = []), this.itemsRef[s] = t;
    }, this.autoPlay = () => {
      n.count(this.props.children) <= 1 || (this.clearAutoPlay(), this.props.autoPlay && (this.timer = setTimeout(() => {
        this.increment();
      }, this.props.interval)));
    }, this.clearAutoPlay = () => {
      this.timer && clearTimeout(this.timer);
    }, this.resetAutoPlay = () => {
      this.clearAutoPlay(), this.autoPlay();
    }, this.stopOnHover = () => {
      this.setState({ isMouseEntered: !0 }, this.clearAutoPlay);
    }, this.startOnLeave = () => {
      this.setState({ isMouseEntered: !1 }, this.autoPlay);
    }, this.isFocusWithinTheCarousel = () => this.carouselWrapperRef ? !!(document.activeElement === this.carouselWrapperRef || this.carouselWrapperRef.contains(document.activeElement)) : !1, this.navigateWithKeyboard = (t) => {
      if (!this.isFocusWithinTheCarousel())
        return;
      const { axis: s } = this.props, o = s === "horizontal", r = {
        ArrowUp: 38,
        ArrowRight: 39,
        ArrowDown: 40,
        ArrowLeft: 37
      }, p = o ? r.ArrowRight : r.ArrowDown, h = o ? r.ArrowLeft : r.ArrowUp;
      p === t.keyCode ? this.increment() : h === t.keyCode && this.decrement();
    }, this.updateSizes = () => {
      if (!this.state.initialized || !this.itemsRef || this.itemsRef.length === 0)
        return;
      const t = this.props.axis === "horizontal", s = this.itemsRef[0];
      if (!s)
        return;
      const o = t ? s.clientWidth : s.clientHeight;
      this.setState({
        itemSize: o
      }), this.thumbsRef && this.thumbsRef.updateSizes();
    }, this.setMountState = () => {
      this.setState({ hasMount: !0 }), this.updateSizes();
    }, this.handleClickItem = (t, s) => {
      if (n.count(this.props.children) !== 0) {
        if (this.state.cancelClick) {
          this.setState({
            cancelClick: !1
          });
          return;
        }
        this.props.onClickItem(t, s), t !== this.state.selectedItem && this.setState({
          selectedItem: t
        });
      }
    }, this.handleOnChange = (t, s) => {
      n.count(this.props.children) <= 1 || this.props.onChange(t, s);
    }, this.handleClickThumb = (t, s) => {
      this.props.onClickThumb(t, s), this.moveTo(t);
    }, this.onSwipeStart = (t) => {
      this.setState({
        swiping: !0
      }), this.props.onSwipeStart(t);
    }, this.onSwipeEnd = (t) => {
      this.setState({
        swiping: !1,
        cancelClick: !1,
        swipeMovementStarted: !1
      }), this.props.onSwipeEnd(t), this.clearAutoPlay(), this.state.autoPlay && this.autoPlay();
    }, this.onSwipeMove = (t, s) => {
      this.props.onSwipeMove(s);
      const o = this.props.swipeAnimationHandler(
        t,
        this.props,
        this.state,
        this.setState.bind(this)
      );
      return this.setState({
        ...o
      }), !!Object.keys(o).length;
    }, this.decrement = (t = 1) => {
      this.moveTo(
        this.state.selectedItem - (typeof t == "number" ? t : 1)
      );
    }, this.increment = (t = 1) => {
      this.moveTo(
        this.state.selectedItem + (typeof t == "number" ? t : 1)
      );
    }, this.moveTo = (t) => {
      if (typeof t != "number")
        return;
      const s = n.count(this.props.children) - 1;
      t < 0 && (t = this.props.infiniteLoop ? s : 0), t > s && (t = this.props.infiniteLoop ? 0 : s), this.selectItem({
        // if it's not a slider, we don't need to set position here
        selectedItem: t
      }), this.state.autoPlay && this.state.isMouseEntered === !1 && this.resetAutoPlay();
    }, this.onClickNext = () => {
      this.increment(1);
    }, this.onClickPrev = () => {
      this.decrement(1);
    }, this.onSwipeForward = () => {
      this.increment(1), this.props.emulateTouch && this.setState({ cancelClick: !0 });
    }, this.onSwipeBackwards = () => {
      this.decrement(1), this.props.emulateTouch && this.setState({ cancelClick: !0 });
    }, this.changeItem = (t) => (s) => {
      (!R.isKeyboardEvent(s) || s.key === "Enter") && this.moveTo(t);
    }, this.selectItem = (t) => {
      this.setState(
        {
          previousItem: this.state.selectedItem,
          ...t
        },
        () => {
          this.setState(this.animationHandler(this.props, this.state));
        }
      ), this.handleOnChange(
        t.selectedItem,
        n.toArray(this.props.children)[t.selectedItem]
      );
    }, this.getInitialImage = () => {
      const t = this.props.selectedItem, s = this.itemsRef && this.itemsRef[t];
      return (s && s.getElementsByTagName("img") || [])[0];
    }, this.getVariableItemHeight = (t) => {
      const s = this.itemsRef && this.itemsRef[t];
      if (this.state.hasMount && s && s.children.length) {
        const o = s.children[0].getElementsByTagName("img") || [];
        if (o.length > 0) {
          const h = o[0];
          if (!h.complete) {
            const l = () => {
              this.forceUpdate(), h.removeEventListener("load", l);
            };
            h.addEventListener("load", l);
          }
        }
        const p = (o[0] || s.children[0]).clientHeight;
        return p > 0 ? p : null;
      }
      return null;
    };
    const i = {
      initialized: !1,
      previousItem: e.selectedItem,
      selectedItem: e.selectedItem,
      hasMount: !1,
      isMouseEntered: !1,
      autoPlay: e.autoPlay,
      swiping: !1,
      swipeMovementStarted: !1,
      cancelClick: !1,
      itemSize: 1,
      itemListStyle: {},
      slideStyle: {},
      selectedStyle: {},
      prevStyle: {}
    };
    this.animationHandler = typeof e.animationHandler == "function" && e.animationHandler || e.animationHandler === "fade" && C || A, this.state = {
      ...i,
      ...this.animationHandler(e, i)
    };
  }
  componentDidMount() {
    this.props.children && this.setupCarousel();
  }
  componentDidUpdate(e, i) {
    !e.children && this.props.children && !this.state.initialized && this.setupCarousel(), !e.autoFocus && this.props.autoFocus && this.forceFocus(), i.swiping && !this.state.swiping && this.setState({
      ...this.props.stopSwipingHandler(this.props, this.state)
    }), (e.selectedItem !== this.props.selectedItem || e.centerMode !== this.props.centerMode) && (this.updateSizes(), this.moveTo(this.props.selectedItem)), e.autoPlay !== this.props.autoPlay && (this.props.autoPlay ? this.setupAutoPlay() : this.destroyAutoPlay(), this.setState({ autoPlay: this.props.autoPlay }));
  }
  componentWillUnmount() {
    this.destroyCarousel();
  }
  setupCarousel() {
    this.bindEvents(), this.state.autoPlay && n.count(this.props.children) > 1 && this.setupAutoPlay(), this.props.autoFocus && this.forceFocus(), this.setState(
      {
        initialized: !0
      },
      () => {
        const e = this.getInitialImage();
        e && !e.complete ? e.addEventListener("load", this.setMountState) : this.setMountState();
      }
    );
  }
  destroyCarousel() {
    this.state.initialized && (this.unbindEvents(), this.destroyAutoPlay());
  }
  setupAutoPlay() {
    this.autoPlay();
    const e = this.carouselWrapperRef;
    this.props.stopOnHover && e && (e.addEventListener("mouseenter", this.stopOnHover), e.addEventListener("mouseleave", this.startOnLeave));
  }
  destroyAutoPlay() {
    this.clearAutoPlay();
    const e = this.carouselWrapperRef;
    this.props.stopOnHover && e && (e.removeEventListener("mouseenter", this.stopOnHover), e.removeEventListener("mouseleave", this.startOnLeave));
  }
  bindEvents() {
    window.addEventListener("resize", this.updateSizes), window.addEventListener("DOMContentLoaded", this.updateSizes), this.props.useKeyboardArrows && document.addEventListener("keydown", this.navigateWithKeyboard);
  }
  unbindEvents() {
    window.removeEventListener("resize", this.updateSizes), window.removeEventListener("DOMContentLoaded", this.updateSizes);
    const e = this.getInitialImage();
    e && e.removeEventListener("load", this.setMountState), this.props.useKeyboardArrows && document.removeEventListener("keydown", this.navigateWithKeyboard);
  }
  forceFocus() {
    var e;
    (e = this.carouselWrapperRef) == null || e.focus();
  }
  renderItems(e) {
    return this.props.children ? n.map(this.props.children, (i, t) => {
      const s = t === this.state.selectedItem, o = t === this.state.previousItem;
      let r = s && this.state.selectedStyle || o && this.state.prevStyle || this.state.slideStyle || {};
      this.props.centerMode && this.props.axis === "horizontal" && (r = { ...r, minWidth: this.props.centerSlidePercentage + "%" }), this.state.swiping && this.state.swipeMovementStarted && (r = { ...r, pointerEvents: "none" });
      const p = {
        ref: (h) => this.setItemsRef(h, t),
        key: "itemKey" + t + (e ? "clone" : ""),
        className: c.ITEM(
          !0,
          t === this.state.selectedItem,
          t === this.state.previousItem
        ),
        onClick: this.handleClickItem.bind(this, t, i),
        style: r
      };
      return /* @__PURE__ */ u("li", { ...p, children: this.props.renderItem(i, {
        isSelected: t === this.state.selectedItem,
        isPrevious: t === this.state.previousItem
      }) });
    }) : [];
  }
  renderControls() {
    const { showIndicators: e, labels: i, renderIndicator: t, children: s } = this.props;
    return e ? /* @__PURE__ */ u("ul", { className: "control-dots", children: n.map(s, (o, r) => t && t(
      this.changeItem(r),
      r === this.state.selectedItem,
      r,
      i.item
    )) }) : null;
  }
  renderStatus() {
    return this.props.showStatus ? /* @__PURE__ */ u("p", { className: "carousel-status", children: this.props.statusFormatter(
      this.state.selectedItem + 1,
      n.count(this.props.children)
    ) }) : null;
  }
  renderThumbs() {
    return !this.props.showThumbs || !this.props.children || n.count(this.props.children) === 0 ? null : /* @__PURE__ */ u(
      I,
      {
        ref: this.setThumbsRef,
        onSelectItem: this.handleClickThumb,
        selectedItem: this.state.selectedItem,
        transitionTime: this.props.transitionTime,
        thumbWidth: this.props.thumbWidth,
        labels: this.props.labels,
        emulateTouch: this.props.emulateTouch,
        children: this.props.renderThumbs(this.props.children)
      }
    );
  }
  render() {
    if (!this.props.children || n.count(this.props.children) === 0)
      return null;
    const e = this.props.swipeable && n.count(this.props.children) > 1, i = this.props.axis === "horizontal", t = this.props.showArrows && n.count(this.props.children) > 1, s = t && (this.state.selectedItem > 0 || this.props.infiniteLoop) || !1, o = t && (this.state.selectedItem < n.count(this.props.children) - 1 || this.props.infiniteLoop) || !1, r = this.renderItems(!0), p = r == null ? void 0 : r.shift(), h = r == null ? void 0 : r.pop();
    let l = {
      className: c.SLIDER(!0, this.state.swiping),
      onSwipeMove: this.onSwipeMove,
      onSwipeStart: this.onSwipeStart,
      onSwipeEnd: this.onSwipeEnd,
      style: this.state.itemListStyle || {},
      tolerance: this.props.swipeScrollTolerance
    };
    const m = {};
    if (i) {
      if (l.onSwipeLeft = this.onSwipeForward, l.onSwipeRight = this.onSwipeBackwards, this.props.dynamicHeight) {
        const f = this.getVariableItemHeight(this.state.selectedItem);
        m.height = f || "auto";
      }
    } else
      l.onSwipeUp = this.props.verticalSwipe === "natural" ? this.onSwipeBackwards : this.onSwipeForward, l.onSwipeDown = this.props.verticalSwipe === "natural" ? this.onSwipeForward : this.onSwipeBackwards, l.style = { ...l.style, height: this.state.itemSize }, m.height = this.state.itemSize;
    return /* @__PURE__ */ d(
      "div",
      {
        "aria-label": this.props.ariaLabel,
        className: `ar-Carousel ${c.ROOT(this.props.className)}${this.props.classes ? " " + this.props.classes : ""}`,
        ref: this.setCarouselWrapperRef,
        tabIndex: this.props.useKeyboardArrows ? 0 : void 0,
        children: [
          /* @__PURE__ */ d(
            "div",
            {
              className: c.CAROUSEL(!0),
              style: { width: this.props.width },
              children: [
                !this.props.noMarkers && this.renderControls(),
                this.props.renderArrowPrev(
                  this.onClickPrev,
                  s,
                  this.props.labels.leftArrow
                ),
                /* @__PURE__ */ u(
                  "div",
                  {
                    className: c.WRAPPER(!0, this.props.axis),
                    style: m,
                    children: e ? /* @__PURE__ */ d(
                      v,
                      {
                        tagName: "ul",
                        innerRef: this.setListRef,
                        ...l,
                        allowMouseEvents: this.props.emulateTouch,
                        children: [
                          this.props.infiniteLoop && h,
                          this.renderItems(),
                          this.props.infiniteLoop && p
                        ]
                      }
                    ) : /* @__PURE__ */ d(
                      "ul",
                      {
                        className: c.SLIDER(!0, this.state.swiping),
                        ref: (f) => this.setListRef(f),
                        style: this.state.itemListStyle || {},
                        children: [
                          this.props.infiniteLoop && h,
                          this.renderItems(),
                          this.props.infiniteLoop && p
                        ]
                      }
                    )
                  }
                ),
                this.props.renderArrowNext(
                  this.onClickNext,
                  o,
                  this.props.labels.rightArrow
                ),
                this.renderStatus()
              ]
            }
          ),
          this.renderThumbs()
        ]
      }
    );
  }
}
S.displayName = "Carousel";
S.defaultProps = {
  ariaLabel: void 0,
  axis: "horizontal",
  centerSlidePercentage: 80,
  interval: 3e3,
  labels: {
    leftArrow: "previous slide / item",
    rightArrow: "next slide / item",
    item: "slide item"
  },
  onClickItem: w,
  onClickThumb: w,
  onChange: w,
  onSwipeStart: () => {
  },
  onSwipeEnd: () => {
  },
  onSwipeMove: () => !1,
  preventMovementUntilSwipeScrollTolerance: !1,
  renderArrowPrev: (a, e, i) => /* @__PURE__ */ u(
    "button",
    {
      type: "button",
      "aria-label": i,
      className: c.ARROW_PREV(!e),
      onClick: a
    }
  ),
  renderArrowNext: (a, e, i) => /* @__PURE__ */ u(
    "button",
    {
      type: "button",
      "aria-label": i,
      className: c.ARROW_NEXT(!e),
      onClick: a
    }
  ),
  renderIndicator: (a, e, i, t) => /* @__PURE__ */ u(
    "li",
    {
      className: c.DOT(e),
      onClick: a,
      onKeyDown: a,
      value: i,
      role: "button",
      tabIndex: 0,
      "aria-label": `${t} ${i + 1}`
    },
    i
  ),
  renderItem: (a) => a,
  renderThumbs: (a) => {
    const e = n.map(
      a,
      (i) => {
        let t = i;
        if (i.type !== "img" && (t = i && n.toArray(
          i.props.children
        ).find(
          (s) => s.type === "img"
        )), !!t)
          return t;
      }
    );
    return (e == null ? void 0 : e.filter((i) => i).length) === 0 ? (console.warn(
      "No images found! Can't build the thumb list without images. If you don't need thumbs, set showThumbs={false} in the Carousel. Note that it's not possible to get images rendered inside custom components. More info at https://github.com/leandrowd/react-responsive-carousel/blob/master/TROUBLESHOOTING.md"
    ), []) : e;
  },
  statusFormatter: E,
  selectedItem: 0,
  showArrows: !0,
  showIndicators: !0,
  showStatus: !0,
  showThumbs: !0,
  stopOnHover: !0,
  swipeScrollTolerance: 5,
  swipeable: !0,
  transitionTime: 350,
  verticalSwipe: "standard",
  width: "100%",
  animationHandler: "slide",
  swipeAnimationHandler: g,
  stopSwipingHandler: b
};
export {
  S as default,
  E as defaultStatusFormatter,
  w as noop
};
