import "./assets/IconTile.css";
import { jsx as t, jsxs as m } from "react/jsx-runtime";
import { useState as $, useEffect as y } from "react";
import { useNavigate as B } from "react-router-dom";
import { useAppSelector as R } from "./hooks.js";
import { getCurrentTheme as E } from "./store.js";
import { e as p, $ as H } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-redux";
import { ArIconTileTypes as l, ArPopoverSlots as b, ArPopoverPositions as M } from "./types/enums.js";
import { ICON_ROOT as j } from "./config/constants.js";
const Q = (g) => {
  const {
    classes: d,
    fillColor: v,
    hideBorder: I,
    hideFooter: C,
    icon: e,
    iconSize: S,
    onClick: f,
    selectable: o,
    strokeColor: w,
    strokeWidth: N,
    tools: h,
    toolsPlacement: T,
    type: n
  } = g, [c, u] = $(), [r, s] = $(), O = R(E), P = B();
  y(() => {
    !o && r && s(!1);
  }, [o]);
  const k = (a) => a.map((i, L) => {
    const x = /* @__PURE__ */ t(
      p,
      {
        slot: b.ANCHOR,
        ...i.iconProps,
        onClick: i.onClick
      }
    );
    return /* @__PURE__ */ t(
      "span",
      {
        className: "ar-ToolItem flex-center",
        onClick: (A) => {
          A.stopPropagation();
        },
        children: i.children ? /* @__PURE__ */ m(
          H,
          {
            position: M.RIGHTBOTTOM,
            children: [
              x,
              /* @__PURE__ */ t("div", { slot: b.POPOVER, children: k(i.children) })
            ]
          }
        ) : x
      },
      "tool-item-" + e.name + "-" + L
    );
  }), _ = h && /* @__PURE__ */ t(
    "div",
    {
      className: `ar-ToolBar position-absolute${T ? " " + T : ""}${o ? " d-none" : " d-flex"}${c ? " show" : ""}${n ? " " + n : ""}`,
      children: k(h)
    }
  );
  return /* @__PURE__ */ m(
    "span",
    {
      className: `ar-IconTile d-inline-block mx-2 mb-3${I ? "" : " border"}${d ? " " + d : ""}${n === l.LIST ? " d-flex" : ""}${o ? " selectable" : ""}`,
      onMouseEnter: () => u(!0),
      onMouseLeave: () => u(!1),
      onClick: () => f && f(e),
      children: [
        /* @__PURE__ */ m(
          "div",
          {
            className: `ar-IconTile__image position-relative overflow-auto h-100${n === l.LIST ? " flex-v-center px-1" : " flex-center"}`,
            onClick: () => o ? s(!r) : P(`/icon/${e.group}/${e.name}`, { state: e }),
            children: [
              o && /* @__PURE__ */ t(
                p,
                {
                  classes: "ar-IconTile__select-icon position-absolute",
                  icon: r ? "im/ImCheckboxChecked" : "im/ImCheckboxUnchecked"
                }
              ),
              /* @__PURE__ */ t(
                p,
                {
                  size: S,
                  svgB64String: btoa(e.icon),
                  color: c ? "royalblue" : O === "th-light-1" ? "grey" : "white",
                  fillColor: v,
                  strokeColor: w,
                  strokeWidth: N
                }
              ),
              n !== l.LIST && _
            ]
          }
        ),
        !C && /* @__PURE__ */ t(
          "footer",
          {
            className: `ar-IconTile__footer fw-bold text-nowrap overflow-hidden flex-center px-2 ${c ? "font-blue btn-link" : "font-black"}${n === l.LIST ? " flex-grow-1" : ""}`,
            onClick: () => {
              const a = `${j}/${e.group}/${e.name}`;
              o ? s(!r) : navigator.clipboard.writeText(a);
            },
            children: e.name
          }
        )
      ]
    }
  );
};
export {
  Q as default
};
