import { jsx as a, jsxs as I } from "react/jsx-runtime";
import { Component as w, Children as p } from "react";
import n from "./cssClasses.js";
import { b as S } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-router-dom";
import "react-redux";
import f from "./utils/domHelper.js";
const R = (d) => d.hasOwnProperty("key");
class c extends w {
  constructor(i) {
    super(i), this.setItemsWrapperRef = (t) => {
      this.itemsWrapperRef = t;
    }, this.setItemsListRef = (t) => {
      this.itemsListRef = t;
    }, this.setThumbsRef = (t, s) => {
      this.thumbsRef || (this.thumbsRef = []), this.thumbsRef[s] = t;
    }, this.updateSizes = () => {
      if (!this.props.children || !this.itemsWrapperRef || !this.thumbsRef)
        return;
      const t = p.count(this.props.children), s = this.itemsWrapperRef.clientWidth, r = this.props.thumbWidth ? this.props.thumbWidth : f.outerWidth(this.thumbsRef[0]), o = Math.floor(s / r), e = o < t, h = e ? t - o : 0;
      this.setState((m, l) => ({
        itemSize: r,
        visibleItems: o,
        firstItem: e ? this.getFirstItem(l.selectedItem) : 0,
        lastPosition: h,
        showArrows: e
      }));
    }, this.handleClickItem = (t, s, r) => {
      if (!R(r) || r.key === "Enter") {
        const o = this.props.onSelectItem;
        typeof o == "function" && o(t, s);
      }
    }, this.onSwipeStart = () => {
      this.setState({
        swiping: !0
      });
    }, this.onSwipeEnd = () => {
      this.setState({
        swiping: !1
      });
    }, this.onSwipeMove = (t) => {
      let s = t.x;
      if (!this.state.itemSize || !this.itemsWrapperRef || !this.state.visibleItems)
        return !1;
      const r = 0, o = p.count(this.props.children), e = -(this.state.firstItem * 100) / this.state.visibleItems, m = -Math.max(o - this.state.visibleItems, 0) * 100 / this.state.visibleItems;
      e === r && s > 0 && (s = 0), e === m && s < 0 && (s = 0);
      const l = this.itemsWrapperRef.clientWidth, u = e + 100 / (l / s);
      return this.itemsListRef && [
        "WebkitTransform",
        "MozTransform",
        "MsTransform",
        "OTransform",
        "transform",
        "msTransform"
      ].forEach((b) => {
        this.itemsListRef.style[b] = f.translate(
          u,
          "%",
          this.props.axis
        );
      }), !0;
    }, this.slideRight = (t) => {
      this.moveTo(
        this.state.firstItem - (typeof t == "number" ? t : 1)
      );
    }, this.slideLeft = (t) => {
      this.moveTo(
        this.state.firstItem + (typeof t == "number" ? t : 1)
      );
    }, this.moveTo = (t) => {
      t = t < 0 ? 0 : t, t = t >= this.state.lastPosition ? this.state.lastPosition : t, this.setState({
        firstItem: t
      });
    }, this.state = {
      selectedItem: i.selectedItem,
      swiping: !1,
      showArrows: !1,
      firstItem: 0,
      visibleItems: 0,
      lastPosition: 0
    };
  }
  componentDidMount() {
    this.setupThumbs();
  }
  componentDidUpdate(i) {
    this.props.selectedItem !== this.state.selectedItem && this.setState({
      selectedItem: this.props.selectedItem,
      firstItem: this.getFirstItem(this.props.selectedItem)
    }), this.props.children !== i.children && this.updateSizes();
  }
  componentWillUnmount() {
    this.destroyThumbs();
  }
  setupThumbs() {
    window.addEventListener("resize", this.updateSizes), window.addEventListener("DOMContentLoaded", this.updateSizes), this.updateSizes();
  }
  destroyThumbs() {
    window.removeEventListener("resize", this.updateSizes), window.removeEventListener("DOMContentLoaded", this.updateSizes);
  }
  getFirstItem(i) {
    let t = i;
    return i >= this.state.lastPosition && (t = this.state.lastPosition), i < this.state.firstItem + this.state.visibleItems && (t = this.state.firstItem), i < this.state.firstItem && (t = i), t;
  }
  renderItems() {
    var i;
    return (i = this.props.children) == null ? void 0 : i.map((t, s) => {
      const r = n.ITEM(!1, s === this.state.selectedItem), o = {
        key: s,
        ref: (e) => this.setThumbsRef(e, s),
        className: r,
        onClick: this.handleClickItem.bind(
          this,
          s,
          this.props.children && this.props.children[s]
        ),
        onKeyDown: this.handleClickItem.bind(
          this,
          s,
          this.props.children && this.props.children[s]
        ),
        "aria-label": `${this.props.labels.item} ${s + 1}`,
        style: { width: this.props.thumbWidth }
      };
      return /* @__PURE__ */ a("li", { ...o, role: "button", tabIndex: 0, children: t });
    });
  }
  render() {
    if (!this.props.children)
      return null;
    const i = p.count(this.props.children) > 1, t = this.state.showArrows && this.state.firstItem > 0, s = this.state.showArrows && this.state.firstItem < this.state.lastPosition;
    let r = {};
    const o = -this.state.firstItem * (this.state.itemSize || 0), e = f.translate(
      o,
      "px",
      this.props.axis
    ), h = this.props.transitionTime + "ms";
    return r = {
      WebkitTransform: e,
      MozTransform: e,
      MsTransform: e,
      OTransform: e,
      transform: e,
      msTransform: e,
      WebkitTransitionDuration: h,
      MozTransitionDuration: h,
      MsTransitionDuration: h,
      OTransitionDuration: h,
      transitionDuration: h,
      msTransitionDuration: h
    }, /* @__PURE__ */ a("div", { className: n.CAROUSEL(!1), children: /* @__PURE__ */ I("div", { className: n.WRAPPER(!1), ref: this.setItemsWrapperRef, children: [
      /* @__PURE__ */ a(
        "button",
        {
          type: "button",
          className: n.ARROW_PREV(!t),
          onClick: () => this.slideRight(),
          "aria-label": this.props.labels.leftArrow
        }
      ),
      i ? /* @__PURE__ */ a(
        S,
        {
          tagName: "ul",
          className: n.SLIDER(!1, this.state.swiping),
          onSwipeLeft: this.slideLeft,
          onSwipeRight: this.slideRight,
          onSwipeMove: this.onSwipeMove,
          onSwipeStart: this.onSwipeStart,
          onSwipeEnd: this.onSwipeEnd,
          style: r,
          innerRef: this.setItemsListRef,
          allowMouseEvents: this.props.emulateTouch,
          children: this.renderItems()
        }
      ) : /* @__PURE__ */ a(
        "ul",
        {
          className: n.SLIDER(!1, this.state.swiping),
          ref: (m) => this.setItemsListRef(m),
          style: r,
          children: this.renderItems()
        }
      ),
      /* @__PURE__ */ a(
        "button",
        {
          type: "button",
          className: n.ARROW_NEXT(!s),
          onClick: () => this.slideLeft(),
          "aria-label": this.props.labels.rightArrow
        }
      )
    ] }) });
  }
}
c.displayName = "Thumbs";
c.defaultProps = {
  axis: "horizontal",
  labels: {
    leftArrow: "previous slide / item",
    rightArrow: "next slide / item",
    item: "slide item"
  },
  selectedItem: 0,
  thumbWidth: 80,
  transitionTime: 350
};
export {
  c as default
};
