import "./assets/UserOptions.css";
import { jsx as o, jsxs as e } from "react/jsx-runtime";
import { getLoggedIn as E, getUser as U, setRightPanelContent as n, notify as I, setLoggedIn as _ } from "./store.js";
import { useAppSelector as c, useAppDispatch as P } from "./hooks.js";
import { P as t, $ as C, e as l, a as T } from "./UserOptions-d360c716-cc2f77cb.js";
import "react";
import "react-router-dom";
import "react-redux";
import { ArSizes as m, ArButtonVariants as s, ArPopoverPositions as g, ArAnimations as F, ArPopoverSlots as S } from "./types/enums.js";
import "./utils/domHelper.js";
import M from "./utils/helper.js";
import D from "./utils/network.js";
import { ENDPOINTS as d } from "./config/constants.js";
import b from "./config/api-config.js";
import O from "./config/web-config.js";
import { v as k } from "./v4-333bbb31.js";
const h = M.isMobile(), Q = (u) => {
  const { classes: i, isLanding: v, options: f, theme: a } = u, p = c(E), r = P(), L = c(U), N = b.IAM[process.env.NODE_ENV] + d.AUTH.ROOT + d.AUTH.LOGOUT;
  return /* @__PURE__ */ o("div", { className: `ar-UserOptions${i ? " " + i : ""}`, children: v ? /* @__PURE__ */ e("div", { className: "ar-UserOptions__auth-buttons d-flex", children: [
    /* @__PURE__ */ o(
      t,
      {
        classes: "me-3",
        size: m.SMALL,
        variant: s.LINKHOVEREFFECT,
        content: "Login",
        onClick: () => r(
          n({
            name: "LoginProvider",
            props: {
              url: O.IAM[process.env.NODE_ENV] + "/login"
            }
          })
        )
      }
    ),
    /* @__PURE__ */ o(
      t,
      {
        size: m.SMALL,
        variant: s.INFO,
        content: "Sign Up",
        onClick: () => r(
          n({
            name: "LoginProvider",
            props: {
              url: O.IAM[process.env.NODE_ENV] + "/signup"
            }
          })
        )
      }
    )
  ] }) : /* @__PURE__ */ e(
    C,
    {
      position: h ? g.TOPLEFT : g.BOTTOMLEFT,
      animation: F.FADEINOUT,
      transition: !0,
      children: [
        /* @__PURE__ */ e("span", { className: "ar-UserOptions__anchor cursor-pointer", slot: "anchor", children: [
          /* @__PURE__ */ o(
            l,
            {
              classes: "h-100",
              icon: "fa.FaUserCircle",
              size: "1.5rem",
              color: a !== "th-light-1" ? "lightgrey" : "grey",
              hoverColor: a !== "th-light-1" ? "#FFD580" : "orange"
            }
          ),
          !h && /* @__PURE__ */ o(l, { icon: "md.MdKeyboardArrowDown", color: "grey" })
        ] }),
        /* @__PURE__ */ e(
          "div",
          {
            className: "ar-UserOptions__popover flex-h-center flex-column",
            slot: S.POPOVER,
            children: [
              !p && /* @__PURE__ */ o(
                t,
                {
                  variant: s.SUCCESS,
                  content: "Login",
                  onClick: () => {
                    r(n({ name: "LoginProvider" }));
                  }
                }
              ),
              /* @__PURE__ */ o(T, { data: f }),
              p && /* @__PURE__ */ o(
                t,
                {
                  classes: "ar-UserOptions__btn-standout mt-2",
                  variant: s.LINK,
                  content: "Logout",
                  onClick: () => D.post(N, L || {}).then((A) => {
                    A.status === 200 && (r(
                      I({
                        show: !0,
                        message: "You've been logged out!",
                        uid: k()
                      })
                    ), r(_(!1)));
                  })
                }
              )
            ]
          }
        )
      ]
    }
  ) });
};
export {
  Q as default
};
