import "./assets/Accordion.css";
import { jsx as a, jsxs as q } from "react/jsx-runtime";
import { useState as g, useEffect as x } from "react";
import { e as A } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-router-dom";
import "react-redux";
import { ArAccordionVariants as N, ArThemes as E } from "./types/enums.js";
import { v as o } from "./v4-333bbb31.js";
const D = [
  {
    id: o(),
    title: "Slide In",
    content: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut laoreet tellus ante, et gravida massa egestas ac. Maecenas venenatis dui a eros maximus, vitae fringilla metus ultrices. Etiam at lacinia magna. Vestibulum sagittis felis sed diam ullamcorper, vel pharetra quam facilisis. Suspendisse bibendum ante id risus interdum, vel sodales felis egestas. Mauris vitae dui gravida, dictum sem id, accumsan tellus. Aliquam sodales quam efficitur, congue justo a, consectetur ante. Nunc euismod augue ac ante condimentum tincidunt. Quisque bibendum semper velit. Cras sit amet imperdiet dolor, ac aliquet mi. Morbi elementum magna eros, in venenatis nunc laoreet eget. Etiam at lorem suscipit, interdum augue id, scelerisque risus. Suspendisse at nisi lorem. Morbi libero erat, vestibulum at pulvinar at, ultrices ac turpis. Etiam ac leo gravida, semper quam in, tempus ipsum. Phasellus finibus rhoncus cursus. Maecenas dapibus ex ut congue eleifend. Sed luctus consectetur quam, at malesuada enim condimentum non."
  },
  {
    id: o(),
    title: "Slide Out",
    content: /* @__PURE__ */ a(
      "input",
      {
        type: "text",
        className: "p-3 m-3",
        title: "dummy",
        placeholder: "Accordion content..."
      }
    )
  },
  {
    id: o(),
    title: "Fade",
    content: "Donec varius lorem vel orci aliquam, nec venenatis turpis commodo. Ut ac diam nisi. Integer at lorem ac ligula vehicula porta. Proin tempor lorem a nunc auctor, rhoncus porta elit auctor. Duis imperdiet dictum luctus. Sed eget orci mattis, sagittis quam ac, congue arcu. Praesent blandit mattis sem, eget rutrum neque auctor id. Vestibulum eu augue ut nisl tempus iaculis. Nullam id tortor sed ante tincidunt consectetur et eu odio. Aliquam accumsan turpis ac dictum interdum."
  },
  {
    id: o(),
    title: "Rotate",
    content: "Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae; Donec metus augue, tempus vitae neque in, accumsan faucibus velit. Quisque felis lorem, tristique nec finibus consequat, viverra quis nibh. Donec arcu mi, placerat eget pretium non, molestie vitae leo. Nunc cursus id mi quis malesuada."
  },
  {
    id: o(),
    title: "Scale",
    content: "Integer dapibus aliquet bibendum. Quisque id lobortis dolor, in bibendum enim. Cras mollis iaculis metus et tincidunt. Maecenas fermentum porttitor faucibus. Suspendisse feugiat ac enim nec vulputate. Aliquam egestas ante ac tempor blandit. Etiam vehicula, dui sed facilisis rhoncus, quam tortor efficitur sapien, eu imperdiet nisi magna et dui. Nulla a justo odio."
  }
], M = (b) => {
  const {
    classes: s,
    content: t,
    expanded: c,
    id: r,
    isRemovable: d,
    setExpandedId: l,
    theme: m,
    title: p
  } = b, [n, u] = g();
  return x(() => {
    u(c);
  }, [c]), /* @__PURE__ */ q(
    "div",
    {
      className: `ar-AccordionExpansionPanel${s ? " " + s : ""}${n ? " expanded" : ""}`,
      id: r,
      children: [
        /* @__PURE__ */ q(
          "div",
          {
            className: "ar-AccordionExpansionPanel__title flex-v-center px-2 py-1 cursor-pointer",
            onClick: () => {
              u(!n), l && l(r);
            },
            children: [
              /* @__PURE__ */ a("span", { className: "ar-AccordionExpansionPanel__title-expand-icon p-2", children: /* @__PURE__ */ a(
                A,
                {
                  color: E.DARK1 === m ? "white" : "black",
                  icon: "md.MdKeyboardArrowRight"
                }
              ) }),
              p,
              d && /* @__PURE__ */ a(
                A,
                {
                  color: E.DARK1 === m ? "white" : "black",
                  classes: "ms-auto",
                  icon: "md.MdClose"
                }
              )
            ]
          }
        ),
        /* @__PURE__ */ a("div", { className: "ar-AccordionExpansionPanel__content", children: typeof t == "string" ? /* @__PURE__ */ a("div", { className: "p-3", children: t }) : t })
      ]
    }
  );
}, V = (b) => {
  const {
    appearance: s,
    classes: t,
    data: c,
    demo: r,
    firstExpanded: d,
    isRemovable: l,
    theme: m,
    variant: p
  } = b, [n, u] = g(), [f, h] = g(), e = c || r && D;
  return x(() => {
    e && (d && (e[0] && (e[0].expanded = !0), u(e[0].id)), h(e));
  }, [e, d]), x(() => {
    if (p === N.LIMITED) {
      const i = [...e];
      i.forEach((v) => v.expanded = n === v.id), h(i);
    }
  }, [n, p, e]), /* @__PURE__ */ a(
    "div",
    {
      className: `ar-Accordion${t ? " " + t : ""}${s ? " " + s : ""}`,
      children: f == null ? void 0 : f.map((i, v) => (i.setExpandedId = u, i.isRemovable = i.isRemovable !== void 0 ? i.isRemovable : !!l, /* @__PURE__ */ a(
        M,
        {
          theme: m,
          ...i
        },
        "accordion-expansion-panel-" + v
      )))
    }
  );
};
export {
  V as default
};
