import "./assets/BrowserIncompatibility.css";
import { jsxs as u, jsx as s } from "react/jsx-runtime";
import { e as w, k as v, O as g } from "./UserOptions-d360c716-cc2f77cb.js";
import { useState as N, useEffect as y } from "react";
import { useNavigate as C } from "react-router-dom";
import "react-redux";
import _ from "./utils/helper.js";
import { v as x } from "./v4-333bbb31.js";
let b;
const I = (c) => {
  const {
    classes: i,
    closeable: l,
    demo: e,
    message: p,
    position: r,
    show: o,
    theme: a,
    type: n,
    timeout: t,
    uid: f
  } = c, [k, h] = N();
  y(() => {
    (o || e) && (setTimeout(() => h("show"), 0), (!e || t) && (clearTimeout(b), b = setTimeout(() => {
      var d;
      h(""), (d = window.top) == null || d.postMessage({ ar: null }, "*");
    }, t || 5e3)));
  }, [e, o, t, f]);
  let m;
  switch (n) {
    case "success":
      m = "bs/BsCheckCircle";
      break;
    case "warning":
      m = "vsc/VscWarning";
      break;
    case "error":
      m = "vsc/VscError";
      break;
    case "information":
    default:
      m = "vsc/VscInfo";
  }
  return /* @__PURE__ */ u(
    "div",
    {
      className: `ar-Alert position-fixed d-flex ${r || "top-center"}${i ? " " + i : ""} ${n || "information"}${k ? " " + k : ""}`,
      children: [
        /* @__PURE__ */ s("span", { className: "ar-Alert__icon d-inline-block p-2", children: /* @__PURE__ */ s(
          w,
          {
            icon: m,
            color: a && a === "th-dark-1" ? "white" : "black",
            theme: a,
            classes: "stroke-color"
          }
        ) }),
        /* @__PURE__ */ s("span", { className: "ar-Alert__text d-inline-block p-2 me-2", children: p || "This is a dummy alert" }),
        l && /* @__PURE__ */ s(
          "span",
          {
            className: "ar-Alert__close-icon position-absolute",
            onClick: () => {
              var d;
              h(""), (d = window.top) == null || d.postMessage({ ar: null }, "*");
            },
            children: /* @__PURE__ */ s(
              v,
              {
                src: `${g}/io5/IoClose${n === "success" ? "/white" : ""}`
              }
            )
          }
        )
      ]
    }
  );
}, $ = (c) => {
  const {
    classes: i,
    label: l,
    to: e,
    children: p,
    onClick: r,
    openInNew: o,
    preemptNavigation: a
  } = c, n = C();
  return /* @__PURE__ */ s(
    "div",
    {
      className: `ar-Link btn btn-link${i ? " " + i : ""}`,
      onClick: (t) => {
        a || e && (e.startsWith("http://") || e.startsWith("https://") || o ? o ? window.open(e, "_blank") : window.open(e) : n(e)), r && r(t);
      },
      children: l || p
    }
  );
};
const z = (c) => {
  const { applicationName: i, moreLink: l, theme: e } = c, p = "https://notabuck.com/armco-design-system/docs/devices", r = '"My Awesome App"', o = l || p;
  return /* @__PURE__ */ u("div", { className: "ar-BrowserIncompatibility p-3 flex-center flex-column", children: [
    /* @__PURE__ */ s(
      w,
      {
        icon: "vsc.VscRunErrors",
        size: "8rem",
        color: e && e === "th-dark-1" ? "white" : "black",
        classes: "mb-3",
        theme: e
      }
    ),
    /* @__PURE__ */ u("h5", { className: "mb-3", children: [
      i || r,
      " can not run on this browser"
    ] }),
    /* @__PURE__ */ s("p", { className: "mb-2", children: "Supported browsers are Google Chrome v51+ & Microsoft's Edge v32+" }),
    /* @__PURE__ */ s("p", { children: "For More details you can also check the below link" }),
    /* @__PURE__ */ s(
      $,
      {
        to: o,
        label: o,
        classes: "ar-BrowserIncompatibility__help-link px-3 py-2",
        onClick: () => {
          var t;
          _.copyToClipboard(o), (t = window.top) == null || t.postMessage(
            {
              ar: {
                position: "bottom-left",
                type: "success",
                closeable: !0,
                message: "Link Copied!",
                show: !0
              }
            },
            "*"
          );
        },
        preemptNavigation: !0
      }
    ),
    /* @__PURE__ */ s(I, { message: "Link Copied!", uid: x() })
  ] });
};
export {
  z as default
};
