import "./assets/Calendar.css";
import { jsxs as p, jsx as m } from "react/jsx-runtime";
import { useState as s, useEffect as _ } from "react";
import { P as T } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-router-dom";
import "react-redux";
import q from "./MonthSelector.js";
import G from "./JustCalendar.js";
import I from "./EventForm.js";
import K from "./MonthNavigator.js";
import { ArCalViews as D, ArSizes as M, ArButtonVariants as Q } from "./types/enums.js";
import u from "./helper.js";
const a = new u({ siblingMonths: !0, weekStart: 1 }), v = /* @__PURE__ */ new Date(), de = (O) => {
  const {
    allowEventSetting: w,
    classes: x,
    events: b,
    customDayEventSetter: U,
    hasTimeControls: j,
    isSingleSelect: l,
    maxDate: W,
    minDate: Z,
    miniMode: r,
    onDateSelected: n,
    startDate: h,
    endDate: S,
    theme: k
  } = O, [z, H] = s(), [d, g] = s(v), [t, f] = s(), [y, c] = s(), [R, X] = s(), [B, F] = s(), [C, E] = s(
    D.CALENDAR
  ), [V, N] = s(), i = t || {
    day: v.getDay(),
    month: v.getMonth(),
    year: v.getFullYear()
  }, [Y, A] = s(
    (i == null ? void 0 : i.year) && Math.floor(i.year / 10) * 10
  ), [$, L] = s(
    i == null ? void 0 : i.year
  );
  _(() => {
    h && f({
      year: h.getFullYear(),
      month: h.getMonth(),
      day: h.getDay()
    });
  }, [h]), _(() => {
    S && c({
      year: S.getFullYear(),
      month: S.getMonth(),
      day: S.getDay()
    });
  }, [S]), _(() => {
    if (d) {
      const e = d.getFullYear(), o = d.getMonth(), P = a.getCalendar(e, o);
      H(P);
    }
  }, [d]);
  const J = (e, o) => {
    if (!t || l) {
      f(e), a.setStartDate(e), n && n(l ? e : { startDate: e });
      return;
    }
    t && y ? u.compare(t, e) === -1 && u.compare(e, y) === -1 ? (a.setEndDate(e), c(e), n && n(
      l ? e : { startDate: t, endDate: e }
    )) : (a.setEndDate(null), c(null), a.setStartDate(e), f(e), n && n(
      l ? e : { startDate: e, endDate: null }
    )) : (u.compare(e, t) === -1 ? (c(t), a.setEndDate(t), f(e), a.setStartDate(e), n && n(
      l ? e : { startDate: e, endDate: t }
    )) : (c(e), a.setEndDate(e), n && n(
      l ? e : { startDate: t, endDate: e }
    )), F(null)), o && w && (X(e), E(D.EVENT_FORM));
  };
  return /* @__PURE__ */ p(
    "div",
    {
      className: `ar-Calendar w-100 h-100 d-flex flex-column${j ? " has-time-controls" : ""}${x ? " " + x : ""}`,
      children: [
        d && /* @__PURE__ */ m(
          K,
          {
            currentDecade: Y,
            currentMonthNavView: V,
            currentView: C,
            currentYear: $,
            miniMode: r,
            refDate: d,
            setCurrentDecade: A,
            setCurrentMonthNavView: N,
            setCurrentView: E,
            setCurrentYear: L,
            setRefDate: g,
            theme: k
          }
        ),
        /* @__PURE__ */ p(
          "div",
          {
            className: `ar-Calendar__cal-event-decade-month-year-selector d-flex flex-1 position-relative overflow-hidden border-bottom${C === D.MONTH_YEAR_SELECTOR ? " to-month-year" : ""}${C === D.EVENT_FORM ? " to-event-form" : ""}${r ? " is-mini" : ""}`,
            children: [
              /* @__PURE__ */ m(
                G,
                {
                  allowEventSetting: w,
                  calHelper: a,
                  calendar: z,
                  endDate: y,
                  hovered: B,
                  isSingleSelect: l,
                  miniMode: r,
                  onDateSelected: J,
                  setHovered: F,
                  startDate: t
                }
              ),
              /* @__PURE__ */ m(
                q,
                {
                  currentDecade: Y,
                  currentMonthNavView: V,
                  currentView: C,
                  currentYear: $,
                  miniMode: r,
                  onMonthSelect: (e) => {
                    E(D.CALENDAR), g(e);
                  },
                  setCurrentDecade: A,
                  setCurrentMonthNavView: N,
                  setCurrentView: E,
                  setCurrentYear: L
                }
              ),
              R && /* @__PURE__ */ m(
                I,
                {
                  events: b,
                  miniMode: r,
                  selectedDate: R
                }
              )
            ]
          }
        ),
        /* @__PURE__ */ p(
          "div",
          {
            className: `ar-Calendar__footer flex-v-center${r ? " p-2" : " px-3 py-2"}${C === D.EVENT_FORM ? " h-0 overflow-hidden" : ""}`,
            children: [
              t && !r && /* @__PURE__ */ m("div", { className: "ar-Calendar__status justify-self-start", children: /* @__PURE__ */ p("span", { className: "fw-bold", children: [
                u.toString(t),
                y && " - " + u.toString(y)
              ] }) }),
              /* @__PURE__ */ p("div", { className: "ar-Calendar__controls ms-auto d-flex", children: [
                /* @__PURE__ */ m(
                  T,
                  {
                    content: "Clear",
                    classes: r ? "me-2" : "me-3",
                    size: r ? M.XSMALL : M.SMALL,
                    variant: Q.SECONDARY,
                    onClick: () => {
                      f(null), c(null), a.setStartDate(null), a.setEndDate(null);
                    },
                    disabled: !t
                  }
                ),
                /* @__PURE__ */ m(
                  T,
                  {
                    content: "Today",
                    size: r ? M.XSMALL : M.SMALL,
                    onClick: () => {
                      const e = v, o = {
                        day: e.getDay(),
                        month: e.getMonth(),
                        year: e.getFullYear()
                      };
                      f(o), c(null), a.setStartDate(o), a.setEndDate(null), g(e), A(Math.floor(o.year / 10) * 10), L(o.year), N(null), E(D.CALENDAR), n && n(
                        l ? o : { startDate: o, endDate: null }
                      );
                    }
                  }
                )
              ] })
            ]
          }
        )
      ]
    }
  );
};
export {
  de as default
};
