import { jsx as a, jsxs as g, Fragment as w } from "react/jsx-runtime";
import { useState as j, useEffect as $ } from "react";
import { $ as D, g as E, I as y, e as I, H as L, U as A, h as B, f as P } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-router-dom";
import "react-redux";
import { d as R } from "./Pill-41763d7d.js";
import { B as M } from "./ArViz-46d1650a.js";
import { S as T } from "./SelectionPill-ae8d2d1e.js";
import H from "./utils/helper.js";
const V = (h) => {
  const { classes: t, data: c, onChange: s } = h, [r, p] = j(c);
  $(() => {
    p(c);
  }, [c]);
  const F = (e, u) => {
    const i = r.findIndex(
      (b) => b.label === e
    ), n = r[i];
    r.splice(i, 1), p([...r]), s && s(n, "all");
  };
  return /* @__PURE__ */ a("div", { className: `ar-Pillbox${t ? " " + t : ""}`, children: r && r.map((e) => /* @__PURE__ */ a(
    R,
    {
      label: e.label,
      data: e,
      deletable: e.deletable,
      onDelete: F
    }
  )) });
}, z = (h) => {
  const { clickHandler: t, classes: c, hideHeader: s, label: r, tags: p } = h;
  return /* @__PURE__ */ a("div", { className: `ar-Tags w-100${c ? " " + c : ""}`, children: /* @__PURE__ */ g("div", { className: "h-100", children: [
    !s && /* @__PURE__ */ g("div", { className: "ar-Tags__header fw-bold border-bottom py-1 px-2", children: [
      /* @__PURE__ */ a("div", { className: "d-inline-block me-2", children: (r || "") + " Tags" }),
      /* @__PURE__ */ g(D, { classes: "d-inline-block", trigger: E.HOVER, children: [
        /* @__PURE__ */ a(
          "div",
          {
            slot: y.POPOVER,
            style: {
              width: "6rem",
              whiteSpace: "normal",
              lineHeight: "1.2rem"
            },
            children: "Please use up/down arrows to indicate if a tag matches the icon."
          }
        ),
        /* @__PURE__ */ a(
          I,
          {
            icon: "md.MdInfoOutline",
            slot: y.ANCHOR
          }
        )
      ] })
    ] }),
    /* @__PURE__ */ a("div", { className: "ar-Tags__container flex-h-center", children: /* @__PURE__ */ a(
      M,
      {
        clickHandler: t,
        type: L.BUBBLE,
        data: p
      }
    ) })
  ] }) });
}, G = (h) => {
  const { onSelectionChanged: t } = h, c = Array.from(Array(26)).map((s, r) => r + 65).map((s) => String.fromCharCode(s));
  return /* @__PURE__ */ g("div", { className: "c-AlphabetFilter", children: [
    /* @__PURE__ */ a("label", { className: "c-AlphabetFilter__label label", children: "Select icon starting with" }),
    /* @__PURE__ */ a("div", { className: "c-AlphabetFilter__pill-container", children: c.map((s) => /* @__PURE__ */ a(
      T,
      {
        classes: "rounded me-2 mb-3",
        data: { label: s },
        size: A.SMALL,
        onClick: (r) => t(r, "alphabet")
      }
    )) })
  ] });
}, U = (h) => {
  const { categoryGroups: t, currentCategoryFilters: c, onFilterChange: s } = h, r = (e, u) => {
    let i = c;
    i || (i = {});
    let n = i[u], b = -1;
    n ? b = n == null ? void 0 : n.findIndex(
      (v) => v.value === e.value
    ) : (n = [], i[u] = n), b === -1 ? n.push(e) : n.splice(b, 1), s(i, "categories");
  }, p = (e, u) => e && /* @__PURE__ */ a("div", { className: "ar-CategoryFilter__pill-container", children: Object.keys(e).map((i) => /* @__PURE__ */ a(
    T,
    {
      classes: "rounded me-2 mb-3",
      data: { label: i },
      size: A.SMALL,
      onClick: (n) => r(n, u)
    }
  )) }), F = Object.keys(t).map((e) => /* @__PURE__ */ g("div", { className: "ar-CategoryFilter__group", children: [
    /* @__PURE__ */ a("label", { className: "ar-CategoryFilter__label label", children: B.toCamelCase(e, " ", !0) }),
    /* @__PURE__ */ a("div", { className: "ar-CategoryFilter__filters", children: p(t[e], e) })
  ] }));
  return /* @__PURE__ */ a("div", { className: "ar-CategoryFilter", children: F });
};
const ee = (h) => {
  const {
    config: t,
    clickHandler: c,
    data: s,
    filteredData: r,
    initialFilters: p,
    onFilterChange: F
  } = h, [e, u] = j(
    p
  ), i = r || s, n = i && i.length, b = t.count !== void 0 && H.generateSlices(n || 0, t.count || 0, "range"), v = (l, f) => {
    var m, C;
    const o = e ? { ...e } : {};
    switch (f) {
      case "alphabet":
        let d = o[f];
        d || (d = [], o[f] = d), d = d;
        const x = d.findIndex(
          (O) => O.value === (l == null ? void 0 : l.value)
        );
        x > -1 ? d.splice(x, 1) : d.push(l);
        break;
      case "all":
        const _ = (m = l == null ? void 0 : l.data) == null ? void 0 : m.type;
        if (_) {
          if (_ === "alphabet")
            o[_] = [];
          else if (_ === "categories") {
            const O = e && e[_], S = (C = l == null ? void 0 : l.data) == null ? void 0 : C.subType;
            O && S && (O[S] = []);
          }
        }
        break;
      case "categories":
      case "count":
      default:
        o[f] = l;
    }
    u(o), F && F(o);
  }, N = [];
  return e && Object.keys(e).forEach((l) => {
    var f;
    if (l === "count" && N.push({
      label: /* @__PURE__ */ g(w, { children: [
        "count:",
        " ",
        /* @__PURE__ */ a("strong", { children: (f = e[l]) == null ? void 0 : f.value })
      ] }),
      data: { filterData: e[l], type: l }
    }), l === "alphabet" && e[l] && e[l].length > 0) {
      const o = e[l].map((m) => m.value).join(" OR ");
      N.push({
        label: `starts:${o}`,
        data: { filterData: e[l], type: l },
        deletable: !0
      });
    }
    if (l === "categories") {
      const o = e[l];
      o && Object.keys(o).forEach((m) => {
        const C = o[m];
        if (C && C.length > 0) {
          const d = C.map((x) => x.value).join(" OR ");
          N.push({
            label: `${m}:${d}`,
            data: { filterData: C, type: l, subType: m },
            deletable: !0
          });
        }
      });
    }
  }), /* @__PURE__ */ g("div", { className: "ar-Filters p-3 h-100 overflow-auto w-100", children: [
    /* @__PURE__ */ a("h5", { children: "Filters" }),
    "count" in t && /* @__PURE__ */ g(w, { children: [
      /* @__PURE__ */ a(
        P,
        {
          classes: "mb-3",
          context: "count",
          id: "icon-range-selector",
          label: "Select a range",
          options: b || [],
          onSelectionChanged: (l) => {
            v(l, "count");
          }
        }
      ),
      /* @__PURE__ */ a(
        V,
        {
          classes: "mb-3",
          data: N,
          onChange: v
        }
      )
    ] }),
    t.alphabet && /* @__PURE__ */ a(G, { onSelectionChanged: v }),
    "categories" in t && /* @__PURE__ */ a(
      U,
      {
        categoryGroups: H.generateCategories(s, t.categories),
        onFilterChange: v,
        currentCategoryFilters: e && e.categories ? e.categories : {}
      }
    ),
    /* @__PURE__ */ a(
      z,
      {
        clickHandler: c,
        classes: "col-12 h-75",
        label: "test",
        tags: t.tags,
        hideHeader: !0
      }
    )
  ] });
};
export {
  ee as default
};
