import { jsx as r, jsxs as v, Fragment as D } from "react/jsx-runtime";
import { e as d } from "./UserOptions-d360c716-cc2f77cb.js";
import "react";
import "react-router-dom";
import "react-redux";
import { ArCalViews as l, ArMonthSelectorViews as t, ArThemes as m } from "./types/enums.js";
import N from "./helper.js";
import { MONTH_INDEX as E } from "./config/constants.js";
const C = (c, n) => {
  const e = n || c.getFullYear(), o = Math.floor(e / 10) * 10, a = o + 10;
  return o + 1 + " - " + a;
}, p = (c, n) => {
  const e = n || c.getFullYear(), o = Math.floor(e / 100) * 100, a = o + 100;
  return o + 1 + " - " + a;
}, w = (c) => {
  const {
    currentDecade: n,
    currentMonthNavView: e,
    currentView: o,
    currentYear: a,
    miniMode: s,
    refDate: i,
    setCurrentDecade: M,
    setCurrentMonthNavView: A,
    setCurrentView: g,
    setCurrentYear: f,
    setRefDate: h,
    theme: u
  } = c;
  return /* @__PURE__ */ r(
    "div",
    {
      className: `ar-MonthNavigator border-bottom d-flex${s ? " is-mini px-0 py-1" : " px-3 py-2"}${o === l.MONTH_YEAR_SELECTOR ? " to-month-year" : ""}${t.MONTH === e ? " to-month-selector" : ""}`,
      children: /* @__PURE__ */ v("div", { className: "d-flex w-100", children: [
        /* @__PURE__ */ r(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => h(N.getPreviousYear(i)),
            children: /* @__PURE__ */ r(
              d,
              {
                icon: "ai/AiOutlineDoubleLeft",
                color: u === m.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: s ? "30" : "100"
              }
            )
          }
        ),
        /* @__PURE__ */ r(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => {
              o === l.CALENDAR ? h(N.getPreviousMonth(i)) : e === t.MONTH ? f((a || i.getFullYear()) - 1) : M(
                (n || 2e3) - (e === t.DECADE ? 100 : 10)
              );
            },
            children: /* @__PURE__ */ r(
              d,
              {
                icon: "ai/AiOutlineLeft",
                color: u === m.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: s ? "30" : "100"
              }
            )
          }
        ),
        /* @__PURE__ */ r(
          "div",
          {
            className: `ar-MonthNavigator__nav-button ar-MonthNavigator__month d-inline-flex flex-center cursor-pointer overflow-auto${e === t.DECADE ? " disabled" : ""}`,
            onClick: () => {
              o === l.CALENDAR && g(l.MONTH_YEAR_SELECTOR), e === t.MONTH ? A(t.YEAR) : e === t.YEAR ? A(t.DECADE) : A(t.MONTH);
            },
            children: o === l.MONTH_YEAR_SELECTOR ? e === t.MONTH ? a || i.getFullYear() : e === t.YEAR ? C(i, n) : p(i, n) : /* @__PURE__ */ v(D, { children: [
              /* @__PURE__ */ r("span", { className: "me-1", children: E[i.getMonth()] }),
              /* @__PURE__ */ r("span", { children: i.getFullYear() })
            ] })
          }
        ),
        /* @__PURE__ */ r(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => {
              o === l.CALENDAR ? h(N.getNextMonth(i)) : e === t.MONTH ? f((a || i.getFullYear()) + 1) : M(
                (n || 2e3) + (e === t.DECADE ? 100 : 10)
              );
            },
            children: /* @__PURE__ */ r(
              d,
              {
                icon: "ai.AiOutlineRight",
                color: u === m.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: s ? "30" : "100"
              }
            )
          }
        ),
        /* @__PURE__ */ r(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => h(N.getNextYear(i)),
            children: /* @__PURE__ */ r(
              d,
              {
                icon: "ai.AiOutlineDoubleRight",
                color: u === m.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: s ? "30" : "100"
              }
            )
          }
        )
      ] })
    }
  );
};
export {
  w as default
};
