import "./assets/TreeList.css";
import { jsxs as I, jsx as s } from "react/jsx-runtime";
import { useState as x, useEffect as T } from "react";
import { c as P, e as k, P as E, $ as R, x as _ } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-router-dom";
import "react-redux";
import { ArThemes as $, ArSizes as w, ArButtonVariants as H, ArPopoverTriggers as M, ArPopoverSlots as y } from "./types/enums.js";
import { ICON_ROOT as B } from "./config/constants.js";
import "./utils/domHelper.js";
import D from "./utils/helper.js";
const A = D.isMobile(), C = (i, t, e, p, n, u, c, m) => {
  const a = i == null ? void 0 : i.map((d, r) => /* @__PURE__ */ s(
    F,
    {
      hierarchyLevel: t,
      data: d,
      onItemSelect: e,
      isAddButton: d.id === "add-button-id",
      setSelected: p,
      selected: n,
      indentation: u,
      indentationUnit: c,
      theme: m
    },
    "TreeListItem" + r
  ));
  return (i == null ? void 0 : i.length) > 0 ? /* @__PURE__ */ s("ul", { className: "ar-TreeList__list list-unstyled", children: a }) : t === 0 && /* @__PURE__ */ s("i", { className: "flex-center mt-5", children: "List is empty" });
}, F = (i) => {
  const {
    hierarchyLevel: t,
    data: e,
    indentation: p = 0.8,
    indentationUnit: n = "rem",
    isAddButton: u,
    onItemSelect: c,
    selected: m,
    setSelected: a,
    theme: d
  } = i, [r, f] = x(e.expanded), [L, g] = x();
  T(() => {
    f(e.expanded);
  }, [e.expanded]);
  let o = null;
  e.children && (o = C(
    e.children,
    t + 1,
    c,
    a,
    m,
    p,
    n,
    d
  ));
  const S = () => {
    e.onItemSelect && e.onItemSelect(e), c && !e.skipParentSelector ? c(e) : console.warn(
      "Parent Selector not called due to the tree item property skipParentSelector!"
    ), a && a(e.id), o && f(!r);
  };
  return /* @__PURE__ */ I(
    "li",
    {
      className: `ar-TreeListItem position-relative${r ? " expanded" : ""}`,
      children: [
        /* @__PURE__ */ I(
          "span",
          {
            className: `ar-TreeListItem__label flex-v-center py-2 w-100${m && m === e.id ? " selected" : ""}`,
            style: {
              paddingLeft: t > 0 ? p * t + n : 0
            },
            onClick: S,
            children: [
              o ? /* @__PURE__ */ s(
                k,
                {
                  color: d === $.DARK1 ? "white" : "black",
                  icon: `${B}/md/MdKeyboardArrowRight`,
                  classes: `me-1${L ? " hover-highlight" : ""}`,
                  onMouseEnter: () => g(!0),
                  onMouseLeave: () => g(!1),
                  onClick: (h) => {
                    h.stopPropagation(), o && f(!r);
                  }
                }
              ) : /* @__PURE__ */ s(
                "span",
                {
                  className: "d-inline-block",
                  style: { height: "1rem", width: "1.25rem" }
                }
              ),
              u ? /* @__PURE__ */ s(
                E,
                {
                  size: w.SMALL,
                  variant: H.LINKHOVEREFFECT,
                  content: e.label
                }
              ) : /* @__PURE__ */ I(R, { trigger: M.HOVER, children: [
                /* @__PURE__ */ s(
                  "span",
                  {
                    className: `ar-ItemContent${o && !r ? " fw-bold" : ""}`,
                    slot: y.ANCHOR,
                    children: e.label === !0 ? "true" : e.label === !1 ? "false" : e.label
                  }
                ),
                /* @__PURE__ */ s(
                  "div",
                  {
                    className: "ar-ItemContent__tooltip",
                    slot: y.POPOVER,
                    children: e.label === !0 ? "true" : e.label === !1 ? "false" : e.label
                  }
                )
              ] }),
              e.badges && e.badges.map((h, l) => /* @__PURE__ */ s(
                _,
                {
                  classes: `position-static d-inline-flex ${l === 0 ? "ms-auto" : "ms-1"}`,
                  ...h
                }
              ))
            ]
          }
        ),
        /* @__PURE__ */ s("div", { className: r ? "" : "invisible", children: o })
      ]
    }
  );
}, X = (i) => {
  const {
    data: t,
    demo: e,
    firstExpanded: p,
    indentation: n,
    noSearch: u,
    onItemSelect: c,
    theme: m,
    title: a,
    withAddButton: d
  } = i, [r, f] = x(), [L, g] = x(), [o, S] = x();
  p && t && t[0] && (t[0].expanded = !0);
  const h = [
    { label: "parent", children: [{ label: "child1" }, { label: "child2" }] }
  ];
  let l = 0.8, N = "rem";
  if (n) {
    if (n.endsWith("rem"))
      try {
        l = +n.substring(0, n.indexOf("rem")), l = l * (A ? 14 : 16) > (A ? 42 : 48) ? 0.8 : l;
      } catch {
      }
    else if (n.endsWith("px"))
      try {
        l = +n.substring(0, n.indexOf("px")), l = l > (A ? 42 : 48) ? 13 : l, N = "px";
      } catch {
      }
  }
  return T(() => {
    if (t) {
      const b = [...t], v = t.findIndex((O) => O.label === "add-button-id") > -1;
      d && !v && b.push({
        label: "Add",
        id: "add-button-id",
        skipParentSelector: !0,
        onItemSelect: () => {
        }
      }), S(b);
    }
  }, [t, d]), /* @__PURE__ */ I("div", { className: "ar-TreeList", children: [
    a && /* @__PURE__ */ s("strong", { className: "d-block my-2", children: a }),
    !u && /* @__PURE__ */ s(
      P,
      {
        data: o || (e ? h : []),
        onChange: (b, v) => f(v),
        searchFor: ["label"]
      }
    ),
    C(
      r || o || (e ? h : []),
      0,
      c,
      g,
      L,
      l,
      N,
      m
    )
  ] });
};
export {
  X as default
};
